static void Wily2Ascii(Screen& s)
{
    GenericAsciiMaker(s,
// Sky
-1,'.', 0x01,2,
// Shadow
-1,',', 0x00,0,
// Walls
-1,'#', 0x48,1, 0x49,1, 0x4A,1,
        0x50,1, 0x51,1, 0x52,1, // block type 1 (middle piece repeatable)
-1,'&', 0x0A,1, 0x09,1, 0x0A,1,
        0x10,1, 0x11,1, 0x12,1, // pseudo block (looks same as block 1)
-1,'#', 0x4E,1, // platform
-1,'#', 0x61,2, // / edge (bottomside)
-1,'#', 0x60,2, // \ edge (bottomside)
-1,'#', 0x62,2, // / edge (topside)
// Decorations
-1,' ', 0x17,3, 0x16,3, // inside bg, inside shadow
-1,' ', 0x23,2, 0x24,2, // window (preferably 2x2)
// Spike
-1,'^', 0xC4,2,
// Ladder
-1,'|', 0x85,0,
// Boss bg (random colours)
-1,'X', 0x25,3, 0x26,3, 0x27,3,
-2);
}

#define Wily2Char  DummyChar

static Level Wily2 =
{
	7, // level number
	"Wily2",

	// screens:
	{
		{
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"#############..."   "                "
		"######.........."   "                "
		"#####..........."   "                "
		"####............"   "                "
		"###............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		"##.............."   "                "
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   " y             y"
		"................"   "     y          "
		"................"   "                "
		"................"   "                "
		"######...####..."   "    y           "
		"................"   "                "
		"................"   "            e   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "               y"
		"................"   "   y            "
		"................"   "                "
		"................"   "                "
		"######...####..."   "  y             "
		"................"   "                "
		"................"   "                "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		,Right},
		{
		".......^########"   "                "
		"......^#########"   "                "
		".....^##########"   "                "
		"....^###########"   "                "
		"...^############"   "                "
		"..^#############"   "   y            "
		"..##############"   "                "
		"..##############"   "                "
		"....,,,,,,,,,,##"   "  y             "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"####,,,,,,,,,,##"   "            pp  "
		"....####&&######"   "                "
		"....####&&######"   "                "
		"....####&&######"   "                "
		"....####&&######"   "                "
		,Down},
		{
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##&&############"   "  XX            "
		"##&&############"   "  XX            "
		"##&&############"   "                "
		"##&&############"   "                "
		,Down},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            e   "
		"............##.."   "             v  "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "                "
		"............##.."   "             v  "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		,Right},
		{
		".......^########"   "                "
		"......^#########"   "                "
		".....^##########"   "                "
		"....^###########"   "                "
		"...^############"   "                "
		"..^#############"   "                "
		"..##############"   "                "
		"..##############"   "                "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"....,,,,,,,,,,##"   "                "
		"####,,,,,,,,,,##"   "            pp  "
		"....######&&####"   "                "
		"....######&&####"   "                "
		"....######&&####"   "                "
		"....######&&####"   "                "
		,Down},
		{
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##&&############"   "  XX            "
		"##&&############"   "  XX            "
		"##&&############"   "                "
		"##&&############"   "                "
		,Down},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            p   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "       B       B"
		"................"   "                "
		,Right},
		{
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"######...####..."   "                "
		"................"   "                "
		"................"   "            p   "
		"............##.."   "                "
		"................"   "                "
		"................"   "                "
		"................"   "      B       B "
		"................"   "                "
		,Right},
		{
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..........######"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"#############|##"   "                "
		"......#######|##"   "                "
		".......######|##"   "                "
		"........#####|##"   "                "
		".........#### ##"   "                "
		"..........### ##"   "                "
		,Down},
		{
		"..........### ##"   "                "
		"..........### ##"   "                "
		"..........##  ##"   "  U             "
		"..#.......##  ##"   "                "
		"..........## ###"   "                "
		"..........    ##"   "          c     "
		"..........    ##"   "                "
		"......####### ##"   "                "
		"........####  ##"   "            c   "
		".........###  ##"   "                "
		"..........## ###"   "                "
		"..........##  ##"   "             h  "
		"..........##  ##"   "                "
		"..........###|##"   "                "
		"..........### ##"   "                "
		"..........### ##"   "                "
		,Down},
		{
		"..........### ##"   "                "
		"..........### ##"   "                "
		"..........    ##"   "                "
		"..........    ##"   "                "
		"..........    ##"   "                "
		"^^..^^^^^^    ##"   "                "
		"############ ###"   "                "
		"........####  ##"   "             h  "
		".........###  ##"   "             h  "
		"..........### ##"   "                "
		"..........##  ##"   "                "
		"..........##  ##"   "             c  "
		"..........##|###"   "                "
		"..........##|###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		,Down},
		{
		"..........## ###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		"..........## ###"   "                "
		".........###  ##"   "                "
		"........####  ##"   "                "
		".......#####  ##"   "                "
		"......######  ##"   "                "
		"......##      ##"   "                "
		"......##      ##"   "                "
		"......##      ##"   "             h  "
		"......##      ##"   "        h       "
		"......##      ##"   "             h  "
		"......##|#######"   "                "
		"......## #######"   "                "
		"......## #######"   "                "
		,Down},
		{
		"......## #######"   "                "
		"......## #######"   "                "
		"......##      ##"   "                "
		"......##      ##"   "                "
		".....|##      ##"   "             <  "
		".....|##      ##"   "                "
		".....|##      ##"   "             {  "
		".....|##      ##"   "  P             "
		"..#..|##      ##"   "             <  "
		".....|##      ##"   "                "
		".....|##      ##"   "             {  "
		".....|        ##"   "                "
		".....|        ##"   "                "
		".....########|##"   "                "
		".....######## ##"   "                "
		".....######## ##"   "                "
		,Down},
		{
		".....######## ##"   "                "
		".....######## ##"   "                "
		".....###      ##"   "                "
		"....^###      ##"   "        h       "
		"...^####      ##"   "             h  "
		"..^##### #######"   "                "
		".^####        ##"   "                "
		"^#####        ##"   "                "
		"####          ##"   "    >           "
		"####          ##"   "             h  "
		"############# ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##|#############"   "                "
		"## #############"   "                "
		"## #############"   "                "
		,Down},
		{
		"##,#############"   "                "
		"##,#############"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"#XXXXXXXXXXXXXX#"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,End},
	},

	// palette
	{
		15, 43, 24,  7, 
		15, 43, 24, 22, 
		15, 43, 24, 28, 
		15, 24,  9,  7, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 17, 15, 

		15, 43, 24,  7, 
		15, 43, 24, 22, 
		15, 43, 24, 28, 
		15, 48, 16, 16, 
	},

	// actives
	{
	},

	// enemies
	{
	},

	Wily2Ascii, Wily2Char
};

