/*

ti pa

48.3 {49.3} 4A.3
50.3 {51.3} 52.3 = inside block type 1

4B.0 {4C.0} 4D.0
53.0 {54.0} 55.0 = inside block type 2

6F.0 = vertical block

64.1 65.1
6C.1 6D.1 = gutsman decoration

4E.3 = inside floor

38.0 39.0
3A.0 3B.0 = gutsblock

17.2 = inside background
16.2 = inside shadow

C5.0 = ladder

3E.0 = lift path edge (*)
3C.0 = lift path      (-)
3D.0 = lift path hole (/)

63.1 69.1
68.1 6A.1 = teleporter

06.0 = last room door
62.0 = last room floor 

00.0 = black background
00.1 = wily palette 1
00.2 = wily palette 2

AE.0 = spike up (black bg)

*/
static void Wily4Ascii(Screen& s)
{
    for(unsigned y=0; y<16; ++y)
        for(unsigned x=0; x<16; ++x)
        {
            unsigned char c = s.outmap[y*16+x].tile;
            unsigned char p = s.outmap[y*16+x].palette;
            
            char ch = '?';
            /* Classify types.
             *
             *
             *
             */
            switch(c)
            {
                // air:
                case 0x00:
                    if(p == 1) { ch = '1'; break; }
                    if(p == 2) { ch = '2'; break; }
                    ch = '.';
                    break;
                
                case 0x16:
                case 0x17: // inside
                    ch = ' ';
                    break;
              
                case 0x48 ... 0x4A:
                case 0x50 ... 0x52: // block 1
                case 0x4B ... 0x4D:
                case 0x53 ... 0x55: // block 2
                case 0x6F: // vertical block
                case 0x4E: // floor in
                case 0x64: case 0x65:
                case 0x6C: case 0x6D: // gutsman decoration
                    ch = '#';
                    break;

                case 0xAE: //up spike
                case 0xBF: //down spike
                    ch = Ascii_Spike;
                    break;
                
                case 0xC5:
                    ch = Ascii_Ladder;
                    break;
                
                case 0x3E:
                    ch = '*';
                    break;
                case 0x3C:
                    ch = '-';
                    break;
                case 0x3D:
                    ch = '/';
                    break;
                    
                case 0x38:
                case 0x39:
                case 0x3A:
                case 0x3B:
                    ch = Ascii_Guts;
                    break;
                
                case 0x63: case 0x69: // tele top
                    ch = '_';
                    break;
                case 0x68: case 0x6A: // tele bottom
                    ch = '=';
                    break;
                    
                case 0x06:
                    ch = Ascii_WilyDoor;
                    break;
                
                case 0x62:
                    ch = 'W';
                    break;
            }
            
            s.ascii[y*32+x] = ch;
            s.ascii[y*32+x+16] = ' ';
            //printf("%02X",c);
        }
}

#define Wily4Char  DummyChar

static Level Wily4 =
{
	9, // level number
	"Wily4",

	// screens:
	{
		{
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|  #        ##"   "                "
		"##|           ##"   "                "
		"##|    #     ###"   "                "
		"##|           ##"   "                "
		"##        #   ##"   "                "
		"##            ##"   "                "
		"##    ####    ##"   "                "
		"##^^^^####^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"##|#############"   "                "
		"##|#############"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##          ####"   "                "
		"##          ####"   "         P      "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"######..##..####"   "       .   .    "
		"##..##..##..####"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "       v        "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"###############."   "                "
		"###############."   "                "
		"########       ."   "                "
		"########       ."   "                "
		"########|#######"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"..###########|##"   "                "
		"..######     |##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"....############"   "                "
		"....############"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"..............#."   "                "
		"................"   "                "
		"................"   "                "
		"..#.*------/////"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"^^^^^^^^^^^^^^^^"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"############__##"   "                "
		"..............##"   "                "
		"..............##"   "             O  "
		"...|########==##"   "                "
		"...|........####"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"/---------------"   "                "
		"..............##"   "      U    W    "
		"......#....#..##"   "                "
		"..............##"   "                "
		"^^^^^^^^^^^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"__              "   "                "
		"..              "   "                "
		"..              "   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "            P SS"
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Shutter},
		{
		"................"   "                "
		"................"   "X               "
		"................"   "X               "
		"................"   "X               "
		"........222222.."   "X               "
		"........222222.."   "X               "
		"......11111222.."   "X               "
		"......11111222.."   "X               "
		"......11222222.."   "X               "
		"......11222222.."   "X               "
		"........2222...."   "X               "
		"........2222...."   "X               "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		,End},
	},

	// palette
	{
		15, 32,  0,  2, 
		15, 48, 39, 23, 
		15, 28, 11, 15, 
		15, 32,  0, 60, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 42, 15, 

		15, 32,  0,  2, 
		15,  0, 32, 16, 
		15, 16, 32, 16, 
		15, 32,  0, 60, 
	},

	// actives
	{
	},

	// enemies
	{
		Enemy( 0, 0x10,0xFF, 0x6 ),
		Enemy( 1, 0x10,0xFF, 0x6 ),
		Enemy( 2, 0x10,0xFF, 0x2C ),
	},

	Wily4Ascii, Wily4Char
};


